package com.ruoyi.common.pay.tm;

import java.util.*;
import java.util.Map.Entry;

public class StringUtils {

	private static Random random = null;

	/**
	 * 获取随机数
	 * @param length
	 * @return
	 */
	public static String getRandomString(int length) {
		// 定义一个字符串（A-Z，a-z1-9）即62位；
		String str = "zxcvbnmlkjhgfdsaqwertyuiopQWERTYUIOPASDFGHJKLZXCVBNM1234567890";
		// 由Random生成随机数
		if (random == null) {
			random = new Random();
		}
		StringBuffer sb = new StringBuffer();
		// 长度为几就循环几次
		for (int i = 0; i < length; ++i) {
			// 产生0-61的数字
			int number = random.nextInt(62);
			// 将产生的数字通过length次承载到sb中
			sb.append(str.charAt(number));
		}
		// 将承载的字符转换成字符串
		return sb.toString();
	}

	public static String getUUID() {
		return UUID.randomUUID().toString();
	}

	public static String getUUIDNoLine() {
		String s = UUID.randomUUID().toString();
		return s.substring(0, 8) + s.substring(9, 13) + s.substring(14, 18) + s.substring(19, 23) + s.substring(24);
	}

	/**
	 * 参数名ASCII码从小到大排序（字典序）
	 * @param map
	 * @return
	 */
	public static String getAsciiSort(Map<String, String> map) {
		List<Entry<String, String>> infoIds = new ArrayList<Entry<String, String>>(map.entrySet());
		// 对所有传入参数按照字段名的 ASCII 码从小到大排序（字典序）
		Collections.sort(infoIds, new Comparator<Entry<String, String>>() {
			public int compare(Entry<String, String> o1, Entry<String, String> o2) {
				return ((String) o1.getKey()).compareToIgnoreCase((String) o2.getKey());
			}
		});
		// 构造签名键值对的格式
		StringBuilder sb = new StringBuilder();
		for (Entry<String, String> item : infoIds) {
			if (item.getKey() != null || item.getKey() != "") {
				String key = item.getKey();
				String val = item.getValue();
				if (!(val == "" || val == null)) {
					sb.append(key + "=" + val + "&");
				}
			}
		}
		if(sb.toString().endsWith("&")) {
			sb.deleteCharAt(sb.length() - 1);
		}
		return sb.toString();
	}

}
